from casioplot import set_pixel

# http://www.sunshine2k.de/coding/java/TriangleRasterization/TriangleRasterization.html

def hline(x1, x2, y, c):
  while x1 <= x2:
    set_pixel(x1, y, c)
    x1 += 1

def fillBottomFlatTriangle(p1, p2, p3, c):
  p2, p3 = sorted([p2, p3], key=lambda x: x[0])

  invslope1 = (p2[0] - p1[0]) / (p2[1] - p1[1])
  invslope2 = (p3[0] - p1[0]) / (p3[1] - p1[1])

  curx1 = p1[0]
  curx2 = p1[0]

  for scanlineY in range(p1[1], p2[1]+1):
    hline(int(curx1), int(curx2), scanlineY, c)
    curx1 += invslope1
    curx2 += invslope2

def fillTopFlatTriangle(p1, p2, p3, c):
  p1, p2 = sorted([p1, p2], key=lambda x: x[0])

  invslope1 = (p3[0] - p1[0]) / (p3[1] - p1[1]);
  invslope2 = (p3[0] - p2[0]) / (p3[1] - p2[1]);

  curx1 = p3[0];
  curx2 = p3[0];

  for scanlineY in range(p3[1], p1[1], -1):
    hline(int(curx1), int(curx2), scanlineY, c)
    curx1 -= invslope1;
    curx2 -= invslope2;

def drawTriangle(p1, p2, p3, c):
  p1, p2, p3 = sorted([p1, p2, p3], key=lambda x: x[1])

  if p2[1] == p3[1]:
    fillBottomFlatTriangle(p1, p2, p3, c)

  elif p1[1] == p2[1]:
    fillTopFlatTriangle(p1, p2, p3, c)
  else:
    p4 = (
      int(p1[0] + ((p2[1] - p1[1]) / (p3[1] - p1[1])) * (p3[0] - p1[0])), p2[1]);
    fillBottomFlatTriangle(p1, p2, p4, c)
    fillTopFlatTriangle(p2, p4, p3, c)
